Description

History

#2 - 08/06/2021 10:21 AM - Roger Borrello

- File 4984 _chui_comparison.png added

- Subject changed from Decimal format sign not handled properly to Decimal format not handled properly

The display output for a decimal fill-in does not match the 4GL.

In ChUI, we are not handling user data correctly.

Take this example (./uast/sterling.p):

def var
def var
def var
def var
def var
def var

nakedl
naked2
sterll as decimal init 12.
dollarl as decimal init
sterl2 as decimal init 43.
dollar2

as decimal init
as decimal init

as decimal init

define frame f1l

nakedl
naked2
sterll at
dollarl
sterl2 at
dollar2

with 1 down side-labels.

12.
43.
34.
12.
2l .
43.

at row 2 col 8 colon-aligned format
row 3 col 8 colon-aligned format
at row 4 col 8 colon-aligned format "$->,>>>,>>9.99"

34.
2l

34.

21.

row 5 col 8 colon-aligned format " £->,>>>,
at row 6 col 8 colon-aligned format " $->,>>>,>>9.99"

"E—>,>>>,>>9, 99"

at row 1 col 8 colon-aligned format "->,>>>,>>9.99"

view—as fill-in

=>,>>>,>>9.99" view-as fill-in

>>9.99"

display nakedl naked2 sterll dollarl sterl2 dollar2 with frame f1l.
/*display nakedl naked2 with frame f1.*/

output to ./sterling.txt.

message
message
message
message
message
message

"nakedl="string (nakedl,
"naked2="string (naked2,
"sterlingl="string(sterll,
"dollarl="string(dollarl,
"sterling2="string(sterl?2,
"dollar2="string(dollar2,

"—>,>>>,>>9.99") .
" —>,>>>,>>9,

"E—>,>>>,>>9.99") .,

"S—>,>>>,>>9,99") |
£->,>>>,>>9,99") |
" S->,>>>,>>9,.99")

99") .

In ChUI, we get this, where we don't seem to do anything with the user data:

04/28/2024

view—as fill-in

view—as fill-in

view—as fill-in

view—as fill-in
2] Administrator: B File Edit View Search Terminal

nakedl: 12.34

naked2 : 43.21

sterll: (12.34
dollarl: $12.34

ster12: G(43.21
dollar2: %$43.21

#3 - 08/06/2021 10:26 AM - Roger Borrello
Another issue related to format is we don't give an error condition that the 4GL does.
In the testcase mentioned in #5587-2, | had longer fill-in names sterling1 and sterling2. When | tried 4GL ChUI, | received Cannot fit FILL-IN ...

(4027)... error. Apparently there's a different limit set for the label size in ChUI versus GUI. | upped the label length by making it mysterling1 and
received the same error on Progress GUI.

No such error on FWD in ChUI or GUI.

#4 - 08/06/2021 10:29 AM - Roger Borrello
- File 4984_tight colon-aligned_4gl.png added
- File 4984_tight colon-aligned_fwd.png added

Another issue is the alignment of side-labels is a little off in GUI when colon-aligned is set. The alignment doesn't match the longest label like in the
4GL:
4GL

naked:
nakedZ:
sterling:
dollar:

sterling:
dollar2:

FWD
naked: 1

naked2:
sterling:
dollar:
sterling2:
dollar2:
https://proj.goldencode.com/issues/5587#note-2

#5 - 08/06/2021 11:46 AM - Roger Borrello
- File 5587 _extra_space.png added

Another issue is the extra space that comes between the user data, and the first digit. It appears that the sign is replaced with a space, when it may
need to be replaced with a null.

Here is a minor update to the testcase, and resultant output comparison:

def var nakedl as decimal init 12.34.
def var naked2 as decimal init 43.21.
def var sterll as decimal init 12.34.
def var sterl2 as decimal init 43.21.
def var dollarl as decimal init 12.34.
def var dollar2 as decimal init 43.21.

define frame f1l

nakedl at row 1 col 8 colon-aligned format "->,>>>,>>9.99" view—as fill-in
naked2 at row 2 col 8 colon-aligned format " —>,>>>,>>9,99" view—-as fill-in
sterll at row 3 col 8 colon-aligned format "£->,>>>,>>9,.99" view—as fill-in
sterl2 at row 5 col 8 colon-aligned format "£ ->,>>>,>>9.99" view—as fill-in
dollarl at row 4 col 8 colon-aligned format "$->,>>>,>>9.99" view—-as fill-in
dollar2 at row 6 col 8 colon-aligned format "$ ->,>>>,>>9.99" view—as fill-in
with 1 down side-labels

display nakedl naked2 sterll sterl2 dollarl dollar2 with frame f1.

"

nakedl: 12.34 N
nakedZ: 43.21 nakedz:
sterll: £12.34 sterlL:
dollarl: $12.34
sterl2: £ 43.21
dollarz: 5 43.21

dellar1:
sterl2:
dollar2:
#6 - 08/06/2021 03:42 PM - Roger Borrello

| am going to compare how the NumberType.toString handles the format, since the message comes out without the space instead of the negative

sign.

#7 - 08/06/2021 03:48 PM - Roger Borrello
- Assignee set to Roger Borrello

- Status changed from New to WIP
